<template>
  <div>
    <div>
<CModal
      title="Info"
      size="lg"
      fade=true
        backdrop= true
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Material Master</h5>
   
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="15"
      pagination
      hover
      striped
      border
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectMaterial(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectMaterial(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMaterial(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> Add New Material</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">New Material Details</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<!-- <div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div> -->

<div class="form-group">
    <label for="Material_Code">Material Code</label>
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
     <label for="Material_Description">Material Description</label>
<input type="text" name="Material_Description" class="form-control form-control-lg" placeholder="" v-model="newMaterial.material_Description">
</div>

<!-- <div class="form-group">
<input type="text" name="Material_Type_Id" class="form-control form-control-lg" placeholder="Material Type Id"  v-model="newMaterial.material_Type_Id">
</div> -->
<div class="form-group">
     <label for="Material_Type_Id">Material Type </label>
 <select class="form-control" v-model="newMaterial.material_Type_Id" placeholder="Material Type" >
    <!-- <option value= "Select Material Type" selected disabled>Select Material Type</option> -->
    <option v-for="item in materialtypeitems" :value="item.material_Type_Id" :key="item.material_Type_Id">{{ item.material_Type_Name }} </option>
  </select>
</div>

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addMaterials();" > Add Material </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Material Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<!-- <div class="form-group">
<label for="Material_Id">Material Id</label>
<input type="text" label ="Id" name="Material_Id" readonly class="form-control form-control-lg" placeholder= "Material Id" v-model="CurrentMaterial.material_Id">
</div> -->

<div class="form-group">
  <label for="Material_Code">Material Code</label>
<input type="text" name="Material_Code" readonly class="form-control form-control-lg" placeholder="Material Code" v-model="CurrentMaterial.material_Code">
</div>

<div class="form-group">
   <label for="Material_Description">Material Description</label>
<input type="text" name="Material_Description" readonly class="form-control form-control-lg" placeholder="Material Description" v-model="CurrentMaterial.material_Description">
</div>

<div class="form-group">
   <label for="material_Type_Name">Material Type </label>
<input type="text" name="material_Type_Name" readonly class="form-control form-control-lg" placeholder="Material Type Name"  v-model="CurrentMaterial.material_Type_Name">
</div>

<div class="form-group">
   <label for="Entry_Date">Entry Date</label>
<input type="text" name="Entry_Date" readonly class="form-control form-control-lg" placeholder="Entry Date"  v-model="CurrentMaterial.entryDate">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Material</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false; this.getAllMaterialDetails();">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group">
  <label for="Material_Id">Material Id</label>
<input type="text" name="Material_Id"  readonly class="form-control form-control-lg" placeholder="Material Id" v-model="CurrentMaterial.material_Id">
</div> -->

<div class="form-group">
   <label for="Material_Code">Material Code</label>
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="CurrentMaterial.material_Code">
</div>

<div class="form-group">
   <label for="Material_Description">Material Description</label>
<input type="text" name="Material_Description" class="form-control form-control-lg" placeholder="Material Description" v-model="CurrentMaterial.material_Description">
</div>

<!-- <div class="form-group">
  <label for="Material_Type_Id">Material Type</label>
<input type="text" name="Material_Type_Id" class="form-control form-control-lg" placeholder="Material Type Id"  v-model="CurrentMaterial.material_Type_Id">
</div> -->
<div class="form-group">
   <label for="Material_Type_Id">Material Type</label>
 <select class="form-control" v-model="CurrentMaterial.material_Type_Id">
    <!-- <option value= "Select Material Type" selected disabled>Select Material Type</option> -->
    <option v-for="item in materialtypeitems" :value="item.material_Type_Id" :key="item.material_Type_Id">{{ item.material_Type_Name }} </option>
  </select>
</div>

<div class="form-group">

<button class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateMaterials();" > Update Material </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Material</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the material ? </h4>
<h5> You are deleting {{ this.CurrentMaterial.material_Code +' || '+ this.CurrentMaterial.material_Description }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteItem();getAllMaterialDetails();"> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const apiurl =  'FGS_FIFO_Material_Master/'
const items = [
  { key: 'material_Code',  },
  { key: 'material_Description', },
  { key: 'material_Status', },
  { key: 'material_Id',     },
 // { key: 'entryDate',     _style: 'width:1%',  },
  { key: 'material_Type_Name',  }
 ]   
 
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
              { key: 'material_Id' , label: 'Id',},
              { key: 'material_Code', label: 'Code', },
              { key: 'material_Description', label: 'Description',  _style: 'width:30%', },
                { key: 'material_Type_Name' , label: 'Type',},   
            //  { key: 'entryDate' , label: 'Entry Date',_classes: 'font-weight-bold'},
              { key: 'show_details',  label: '',  _style: 'width:35%', },
             
      ],
     
  materialtypeitems:[],
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newMaterial: {material_Id:0,material_Code:"",material_Type_Id:0,material_Description:"",entryDate:new Date(),material_Status:1,}, }
  },



  mounted()
  {
   this.getAllMaterialDetails();
   this.getAllMaterilalTypeDetails();
  },

  methods:
  {
   getAllMaterialDetails: function()
   {

   Vue.axios.get(this.$url + apiurl)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.material_Status == 1);
        this.subitems = response.data.fgS_FIFO_Material_Type_Master;

       }
    });
   },

   
  addMaterials()
  {
     
    if(this.items.find(x => x.material_Code == this.newMaterial.material_Code && x.material_Status == this.newMaterial.material_Status))
    {
     this.SuccessMsg="Material Code " + this.newMaterial.material_Code +" already exist. Please try another Code";
     this.ShowAddModal = true;

    }
    else
    {
     
    Vue.axios.post(this.$url + apiurl,this.newMaterial).then((response)=>{
 
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Record added Successfully.."
       // this.smallModal = true;
               
        this.getAllMaterialDetails();
        location.reload();
       }
    })
    }
   },

  UpdateMaterials()
  {
 Vue.axios.put(this.$url + apiurl+this.CurrentMaterial.material_Id,this.CurrentMaterial,).then((response)=>{
    
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllMaterialDetails();
       }
    })
   },

  deleteItem()
    {

      var material_Id = this.CurrentMaterial.material_Id;
        axios({   method: 'delete',
           url: this.$url + apiurl + material_Id
      
    });
      
        this.SuccessMsg="Material Status Changed to Inactive Succesfully"
        this.getAllMaterialDetails();
         location.reload();
    },
      
  SelectMaterial(Material)
    {
     this.CurrentMaterial=Material;
    },
  
  getAllMaterilalTypeDetails: function()
   {

   Vue.axios.get(this.$url+'FGS_FIFO_MaterialType_Master/')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        
        this.materialtypeitems = response.data.filter(x => x.material_Type_Status == 1);
       

       }
    });
   },
    
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:absolute;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>